package dev.shadowsoffire.apotheosis.potion;

import org.apache.logging.log4j.LogManager;
import dev.shadowsoffire.placebo.recipe.RecipeHelper;
import net.minecraft.ResourceLocationException;
import net.minecraftforge.registries.ForgeRegistries;
import dev.shadowsoffire.placebo.config.Configuration;
import java.io.File;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.entity.animal.Rabbit;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import dev.shadowsoffire.apotheosis.potion.compat.CuriosCompat;
import net.minecraftforge.fml.ModList;
import net.minecraftforge.fml.event.lifecycle.InterModEnqueueEvent;
import net.minecraft.world.item.crafting.RecipeSerializer;
import dev.shadowsoffire.attributeslib.api.ALObjects;
import net.minecraft.world.effect.MobEffect;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.effect.MobEffectInstance;
import dev.shadowsoffire.placebo.tabs.TabFillingRegistry;
import java.util.function.Supplier;
import net.minecraft.world.item.CreativeModeTabs;
import dev.shadowsoffire.apotheosis.ench.objects.GlowyBlockItem;
import dev.shadowsoffire.placebo.registry.RegistryEvent;
import net.minecraft.world.item.crafting.Ingredient;
import java.util.function.Consumer;
import net.minecraftforge.common.MinecraftForge;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.alchemy.PotionBrewing;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.alchemy.Potions;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.InterModComms;
import top.theillusivec4.curios.api.SlotTypeMessage;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.loading.FMLEnvironment;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.resources.ResourceLocation;
import org.apache.logging.log4j.Logger;

public class PotionModule
{
    public static final Logger LOG;
    public static final ResourceLocation POTION_TEX;
    static boolean charmsInCuriosOnly;
    
    @SubscribeEvent
    public void preInit(final Apotheosis.ApotheosisConstruction e) {
        this.reload(null);
        if (FMLEnvironment.dist.isClient()) {
            FMLJavaModLoadingContext.get().getModEventBus().register((Object)PotionModuleClient.class);
        }
        InterModComms.sendTo("curios", "REGISTER_TYPE", () -> new SlotTypeMessage.Builder("charm").size(1).build());
    }
    
    @SubscribeEvent
    public void init(final FMLCommonSetupEvent e) {
        e.enqueueWork(() -> {
            PotionBrewing.m_43513_(Potions.f_43602_, Items.f_42748_, (Potion)Apoth.Potions.RESISTANCE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.RESISTANCE.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_RESISTANCE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.RESISTANCE.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_RESISTANCE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.RESISTANCE.get(), Items.f_42592_, (Potion)Apoth.Potions.SUNDERING.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.LONG_RESISTANCE.get(), Items.f_42592_, (Potion)Apoth.Potions.LONG_SUNDERING.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.STRONG_RESISTANCE.get(), Items.f_42592_, (Potion)Apoth.Potions.STRONG_SUNDERING.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.SUNDERING.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_SUNDERING.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.SUNDERING.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_SUNDERING.get());
            PotionBrewing.m_43513_(Potions.f_43602_, Items.f_42436_, (Potion)Apoth.Potions.ABSORPTION.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.ABSORPTION.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_ABSORPTION.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.ABSORPTION.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_ABSORPTION.get());
            PotionBrewing.m_43513_(Potions.f_43602_, Items.f_42400_, (Potion)Apoth.Potions.HASTE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.HASTE.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_HASTE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.HASTE.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_HASTE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.HASTE.get(), Items.f_42592_, (Potion)Apoth.Potions.FATIGUE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.LONG_HASTE.get(), Items.f_42592_, (Potion)Apoth.Potions.LONG_FATIGUE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.STRONG_HASTE.get(), Items.f_42592_, (Potion)Apoth.Potions.STRONG_FATIGUE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.FATIGUE.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_FATIGUE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.FATIGUE.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_FATIGUE.get());
            if (Apoth.Items.SKULL_FRAGMENT.isPresent()) {
                PotionBrewing.m_43513_(Potions.f_43602_, (Item)Apoth.Items.SKULL_FRAGMENT.get(), (Potion)Apoth.Potions.WITHER.get());
            }
            else {
                PotionBrewing.m_43513_(Potions.f_43602_, Items.f_42679_, (Potion)Apoth.Potions.WITHER.get());
            }
            PotionBrewing.m_43513_((Potion)Apoth.Potions.WITHER.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_WITHER.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.WITHER.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_WITHER.get());
            PotionBrewing.m_43513_(Potions.f_43602_, Items.f_42612_, (Potion)Apoth.Potions.KNOWLEDGE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.KNOWLEDGE.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_KNOWLEDGE.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.KNOWLEDGE.get(), Items.f_42612_, (Potion)Apoth.Potions.STRONG_KNOWLEDGE.get());
            PotionBrewing.m_43513_(Potions.f_43602_, (Item)Apoth.Items.LUCKY_FOOT.get(), Potions.f_43595_);
            PotionBrewing.m_43513_(Potions.f_43602_, Items.f_42780_, (Potion)Apoth.Potions.VITALITY.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.VITALITY.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_VITALITY.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.VITALITY.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_VITALITY.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.VITALITY.get(), Items.f_42592_, (Potion)Apoth.Potions.GRIEVOUS.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.LONG_VITALITY.get(), Items.f_42592_, (Potion)Apoth.Potions.LONG_GRIEVOUS.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.STRONG_VITALITY.get(), Items.f_42592_, (Potion)Apoth.Potions.STRONG_GRIEVOUS.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.GRIEVOUS.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_GRIEVOUS.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.GRIEVOUS.get(), Items.f_42525_, (Potion)Apoth.Potions.STRONG_GRIEVOUS.get());
            PotionBrewing.m_43513_(Potions.f_43596_, Items.f_42592_, (Potion)Apoth.Potions.LEVITATION.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.LEVITATION.get(), Items.f_42731_, (Potion)Apoth.Potions.FLYING.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.FLYING.get(), Items.f_42451_, (Potion)Apoth.Potions.LONG_FLYING.get());
            PotionBrewing.m_43513_((Potion)Apoth.Potions.LONG_FLYING.get(), Items.f_42451_, (Potion)Apoth.Potions.EXTRA_LONG_FLYING.get());
            return;
        });
        Apotheosis.HELPER.registerProvider(factory -> {
            final Ingredient fireRes = Apotheosis.potionIngredient(Potions.f_43610_);
            final Ingredient abs = Apotheosis.potionIngredient((Potion)Apoth.Potions.STRONG_ABSORPTION.get());
            final Ingredient res = Apotheosis.potionIngredient((Potion)Apoth.Potions.RESISTANCE.get());
            final Ingredient regen = Apotheosis.potionIngredient(Potions.f_43589_);
            factory.addShaped((Object)Items.f_42437_, 3, 3, new Object[] { fireRes, regen, fireRes, abs, Items.f_42436_, abs, res, abs, res });
            return;
        });
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::drops);
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::reload);
    }
    
    @SubscribeEvent
    public void items(final RegistryEvent.Register<Item> e) {
        e.getRegistry().registerAll(new Object[] { new GlowyBlockItem.GlowyItem(new Item.Properties()), "lucky_foot", new PotionCharmItem(), "potion_charm" });
        TabFillingRegistry.register(CreativeModeTabs.f_256968_, new Supplier[] { (Supplier)Apoth.Items.LUCKY_FOOT });
        TabFillingRegistry.register(CreativeModeTabs.f_256869_, new Supplier[] { (Supplier)Apoth.Items.POTION_CHARM });
    }
    
    @SubscribeEvent
    public void types(final RegistryEvent.Register<Potion> e) {
        e.getRegistry().registerAll(new Object[] { new Potion("resistance", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19606_, 3600) }), "resistance", new Potion("resistance", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19606_, 9600) }), "long_resistance", new Potion("resistance", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19606_, 1800, 1) }), "strong_resistance", new Potion("absorption", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19617_, 1200, 1) }), "absorption", new Potion("absorption", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19617_, 3600, 1) }), "long_absorption", new Potion("absorption", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19617_, 600, 3) }), "strong_absorption", new Potion("haste", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19598_, 3600) }), "haste", new Potion("haste", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19598_, 9600) }), "long_haste", new Potion("haste", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19598_, 1800, 1) }), "strong_haste", new Potion("fatigue", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19599_, 3600) }), "fatigue", new Potion("fatigue", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19599_, 9600) }), "long_fatigue", new Potion("fatigue", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19599_, 1800, 1) }), "strong_fatigue", new Potion("wither", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19615_, 3600) }), "wither", new Potion("wither", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19615_, 9600) }), "long_wither", new Potion("wither", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19615_, 1800, 1) }), "strong_wither", new Potion("sundering", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.SUNDERING.get(), 3600) }), "sundering", new Potion("sundering", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.SUNDERING.get(), 9600) }), "long_sundering", new Potion("sundering", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.SUNDERING.get(), 1800, 1) }), "strong_sundering", new Potion("knowledge", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.KNOWLEDGE.get(), 2400) }), "knowledge", new Potion("knowledge", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.KNOWLEDGE.get(), 4800) }), "long_knowledge", new Potion("knowledge", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.KNOWLEDGE.get(), 1200, 1) }), "strong_knowledge", new Potion("vitality", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.VITALITY.get(), 4800) }), "vitality", new Potion("vitality", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.VITALITY.get(), 14400) }), "long_vitality", new Potion("vitality", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.VITALITY.get(), 3600, 1) }), "strong_vitality", new Potion("grievous", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.GRIEVOUS.get(), 4800) }), "grievous", new Potion("grievous", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.GRIEVOUS.get(), 14400) }), "long_grievous", new Potion("grievous", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.GRIEVOUS.get(), 3600, 1) }), "strong_grievous", new Potion("levitation", new MobEffectInstance[] { new MobEffectInstance(MobEffects.f_19620_, 2400) }), "levitation", new Potion("flying", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.FLYING.get(), 9600) }), "flying", new Potion("flying", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.FLYING.get(), 18000) }), "long_flying", new Potion("flying", new MobEffectInstance[] { new MobEffectInstance((MobEffect)ALObjects.MobEffects.FLYING.get(), 36000) }), "extra_long_flying" });
    }
    
    @SubscribeEvent
    public void serializers(final RegistryEvent.Register<RecipeSerializer<?>> e) {
        e.getRegistry().register((Object)PotionCharmRecipe.Serializer.INSTANCE, Apoth.Items.POTION_CHARM.getId());
        e.getRegistry().register((Object)PotionEnchantingRecipe.SERIALIZER, "potion_charm_enchanting");
    }
    
    @SubscribeEvent
    public void imcEvent(final InterModEnqueueEvent e) {
        if (ModList.get().isLoaded("curios")) {
            CuriosCompat.sendIMC();
        }
    }
    
    public void drops(final LivingDropsEvent e) {
        final LivingEntity entity = e.getEntity();
        if (entity instanceof final Rabbit rabbit) {
            if (rabbit.m_9236_().f_46441_.m_188501_() < 0.045f + 0.045f * e.getLootingLevel()) {
                e.getDrops().clear();
                e.getDrops().add(new ItemEntity(rabbit.m_9236_(), rabbit.m_20185_(), rabbit.m_20186_(), rabbit.m_20189_(), new ItemStack((ItemLike)Apoth.Items.LUCKY_FOOT.get())));
            }
        }
    }
    
    public void reload(final Apotheosis.ApotheosisReloadEvent e) {
        final Configuration config = new Configuration(new File(Apotheosis.configDir, "potion.cfg"));
        config.setTitle("Apotheosis Potion Module Configuration");
        PotionModule.charmsInCuriosOnly = config.getBoolean("Restrict Charms to Curios", "general", PotionModule.charmsInCuriosOnly, "If Potion Charms will only work when in a curios slot, instead of in the inventory.");
        final String[] defExt = { ForgeRegistries.MOB_EFFECTS.getKey((Object)MobEffects.f_19611_).toString(), ForgeRegistries.MOB_EFFECTS.getKey((Object)MobEffects.f_19616_).toString() };
        final String[] names = config.getStringList("Extended Potion Charms", "general", defExt, "A list of effects that, when as charms, will be applied and reapplied at a longer threshold to avoid issues at low durations, like night vision.\nServer-authoritative.");
        PotionCharmItem.EXTENDED_POTIONS.clear();
        for (final String s : names) {
            try {
                PotionCharmItem.EXTENDED_POTIONS.add(new ResourceLocation(s));
            }
            catch (final ResourceLocationException ex) {
                PotionModule.LOG.error("Invalid extended potion charm entry {} will be ignored.", (Object)s);
            }
        }
        final String[] blacklist = config.getStringList("Blacklisted Potion Charm Effects", "general", new String[0], "A list of effects that, cannot be crafted into Potion Charms.\nServer-authoritative.");
        PotionCharmItem.BLACKLIST.clear();
        for (final String s2 : blacklist) {
            try {
                PotionCharmItem.BLACKLIST.add(new ResourceLocation(s2));
            }
            catch (final ResourceLocationException ex2) {
                PotionModule.LOG.error("Invalid blacklisted potion charm entry {} will be ignored.", (Object)s2);
            }
        }
        if (e == null && config.hasChanged()) {
            config.save();
        }
    }
    
    static {
        LOG = LogManager.getLogger("Apotheosis : Potion");
        POTION_TEX = new ResourceLocation("apotheosis", "textures/potions.png");
        PotionModule.charmsInCuriosOnly = false;
    }
}
